<?php

namespace Bydedi\Security\Event;

use Symfony\Component\HttpFoundation\Response;

/**
 * Class PermissionDeniedEvent
 * @package Bydedi\Security\Event
 */
class PermissionDeniedEvent extends SecurityEvent
{
    /**
     * The response object.
     *
     * @var Response
     */
    protected $response;

    /**
     * Returns the response object.
     *
     * @return Response
     *
     * @api
     */
    public function getResponse()
    {
        return $this->response;
    }

    /**
     * Sets a response and stops event propagation.
     *
     * @param Response $response
     *
     * @api
     */
    public function setResponse(Response $response)
    {
        $this->response = $response;

        $this->stopPropagation();
    }

    /**
     * Returns whether a response was set.
     *
     * @return bool Whether a response was set
     *
     * @api
     */
    public function hasResponse()
    {
        return null !== $this->response;
    }
}
